﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Analyze8EX
{
    class ApplicationHeader
    {
        private Field _initial;

        public ApplicationHeader(byte[] data, int offset)
        {
            _initial = new Field(data, offset);
            if (!_initial.IsGroupedField)
            {
                throw new InvalidDataException("Invalid initial field: " + _initial.FieldId.ToString("X04"));
            }

            SubFields = new List<Field>();
            var index = 0;
            Field next = _initial;
            while (index < _initial.Data.Length)
            {
                next = new Field(_initial.Data, index);
                SubFields.Add(next);

                index += next.FieldHeaderLength + next.Data.Length;
            }
        }

        public int ApplicationSize
        {
            get
            {
                return _initial.Data.Length;
            }
        }

        public List<Field> SubFields { get; internal set; }

        public byte[] RawData
        {
            get
            {
                return _initial.RawData;
            }
        }
    }
}
